﻿using System;
using System.Runtime.InteropServices;
using System.Windows.Forms;
using Brutal.Dev.Events;

namespace Brutal.Dev.Extenstions
{
  public static class DateTimePickerExtensions
  {
#if NETCF
    [DllImport("coredll")]
#else
    [DllImport("user32")]
#endif
    static extern int SendMessage(IntPtr hWnd, uint uMsg,
                                  int wParam, int lParam);

    private const int WM_LBUTTONDOWN = 0x0201;
    private const int WM_LBUTTONUP = 0x0202;

    public static void ShowCalendar(this DateTimePicker picker,
                                    MouseEventArgs clickEvent)
    {
      if (picker != null)
      {
        // Remove any existing event to prevent an infinite loop.
        var suppressor = new EventSuppressor(picker);
        suppressor.Suppress();

        // Get the position on the button.
        int x = picker.Width - 10;
        int y = picker.Height / 2;
        int lParam = x + y * 0x00010000;

        // Ignore if the calendar button was clicked
        if (clickEvent.X < picker.Width - 35)
        {
          SendMessage(picker.Handle, WM_LBUTTONDOWN, 1, lParam);
          SendMessage(picker.Handle, WM_LBUTTONUP, 1, lParam);
        }

        suppressor.Resume();
      }
    }
  }
}
